;------------------------------------------------------------------------
; This is an example scene of three hovering, strange balls and a pillar
; standing on a checkered ground.
;
; Author:          Marcus Geelnard
; Date:            5-Dec-1995
; RayLab version:  1.0
;------------------------------------------------------------------------


Globals:
	picwidth 640  picheight 480	* Set picture dimensions
	recdepth 4
	display 1
;	antialiasrec 2  antialiasthreshold 0.4	* Uncomment to enable
;						* antialiasing
:end


#
#  This texture will be used as default, if these values are not replaced
#  by something else in the objects' declarations:
#

deftexture:
	reflect 0.6 0.6 0.6
	phong 0.7
	phongsize 20
	diffuse 0.6
	ambient 0.2
:end

#
#  Next come three good looking "balls" (they are a bit stretched)
#

Sphere:
	texture:
		color 0.7 0.2 0.3
	:end
	transform:
		scale 0.6 1.3 2
		rotate 40 -32 0
		move -4.5 5 2
	:end
:end

Sphere:
	texture:
		color 0.3 0.9 0.3
	:end
	transform:
		scale 1.6 0.8 1.3
		rotate -40 0 -70
		move -2 4 1
	:end
:end

Sphere:
	texture:
		color 0.5 0.3 1.0
	:end
	transform:
		scale 1.0 1.5 0.6
		rotate 20 -40 0
		move 0 3 3
	:end
:end


#
#  We need a ground aswell... It will be (surprise!) checkered.
#

Plane:
	offset -2
	texture:
		colormap 2
			0.0  0.3 0.2 0.1
			1.0  1.0 0.8 0.6
		pattern checker
		reflect 0.2 0.16 0.1
		ambient 0.1
		diffuse 0.7
		phong 0.4
		transform:
			scale 5 4 3
		:end
	:end
:end


#
# Here comes a texture that will be used for a pillar:
#

deftexture:
	pattern circles
	colormap 4
		0.0  0.9 0.9 0.9
		0.6  0.96 0.94 0.94
		0.75 1.0 1.0 0.9
		1.0  0.9 0.9 0.9
	reflect 0.1 0.1 0.1
	transform:
		scale 0.4 0.7 0.3
	:end
:end

deftransform:			* The pillar will be transformed...
	move  -2 2 0
	rotate 0 0 20
:end

#
#  This is the actual pillar:
#

Box:
	corners
		-5 7 -1.5
		-3 9 2
:end

Box:
	corners
		-5.3 6.7 -2
		-2.7 9.3 -1.5
:end

Box:
	corners
		-5.3 6.7 2
		-2.7 9.3 2.5
:end

Ellipsoid:			* Let's make the pillar more interresting...
	centre -4 7.1 0.25
	radius  0.5 0.3 1.3
:end

Ellipsoid:
	centre -3.1 8 0.25
	radius  0.3 0.5 1.3
:end

Ellipsoid:
	centre -4 8.9 0.25
	radius  0.5 0.3 1.3
:end

Ellipsoid:
	centre -4.9 8 0.25
	radius  0.3 0.5 1.3
:end

deftransform:
	none			* This prevents the rest of the scene from
:end				* being transformed...


#
# This is the bright blue sky (actually a huge sphere)
#

Sphere:
	centre 0 0 0
	radius   2000
	texture:
		default		* Use hardcoded defaults to begin with
		pattern gradient
		colormap 3
			0.0  0.3 0.5 0.9
			0.2  0.1 0.3 0.8
			1.0  0.0 0.0 0.7
		ambient 1.0
		diffuse 0
		phong   0
		reflect 0 0 0
		transform:
			scale 1 1 2000
		:end
	:end
:end


#
# Two light-sources enlightens the scene:
#

Light:
	location  10 -30 30
	color 1 1 1
:end

Light:
	location  -26 15 40
	color 1 0.5 0.6
:end


#
# This is the camera:
#

Camera:
	location  2 -5 1
	viewpoint -2 3 1.5
:end

