/*
	name:	getworld.h

	Input prototypes
	----------------

*/

/* Prototypes for functions defined in getworld.c */
int ischar(int a);
int isletter(int *a);
int isnumber(int a);
int iscomment(int a);
int isnewline(int a);
int getnextkeyword(FILE *f, char *keyword);
int getnextnumber(FILE *f, double *number);
void set_ivalue(long *variable, long value, long min, long max, char *string);
void set_dvalue(double *variable, double value, double min, double max, char *string);
int CreateWorld(char *filename );
int InitNewPlane(FILE *parfile);
int InitNewSphere(FILE *parfile);
int InitNewEllipsoid(FILE *parfile);
int InitNewTriangle(FILE *parfile);
int InitNewBox(FILE *parfile);
int InitNewDisc(FILE *parfile);
int InitNewCylinder(FILE *parfile);
int InitNewLight(FILE *parfile);
int InitCamera(FILE *parfile);
int InitTexture(TEXTURE *TmpTexture, FILE *parfile);
int InitTransform(TRANSFORM *TmpTransform, FILE *parfile);
int InitGlobals(FILE *parfile);
void SetupDefaults(void);
