


FIG2DEV(1)                User Commands                FIG2DEV(1)



NAME
     fig2dev - translates Fig code to various graphics languages


SYNOPSIS
     fig2dev -L language [ -m mag ] [ -f font ] [ -s  fsize  ]  [
     other options ] [ fig-file [ out-file ] ]


DESCRIPTION
     Fig2dev translates fig code in the named fig-file  into  the
     specified  graphics  language and puts them in out-file. The
     default fig-file and out-file are standard input  and  stan-
     dard output, respectively

     Fig (Facility for Interactive Generation of  figures)  is  a
     screen-oriented tool which allows the user to draw and mani-
     pulate objects interactively.  Various versions of  Fig  run
     under the Suntools/Sunview window environment and under ver-
     sion 11 of the X Windows System.  Fig2dev is compatible with
     Fig versions 1.3, 1.4, 2.0, and 2.1.


OPTIONS
     -L    Set the output graphics language.  Valid languages are
          box,  epic,  eepic,  eepicemu, ibmgl, latex, null, pic,
          pictex, ps, pstex, pstex_t,textyl, and tpic.

     -m    Set the magnification at which the figure is  rendered
          to mag. The default is 1.0.

     -f    Set the default font used for text  objects  to  font.
          The default is Roman; the format of this option depends
          on  the  graphics  language  in  use.    In   TeX-based
          languages,  the  font  is the base of the name given in
          lfonts.tex, for instance In PostScript, it is any  font
          name known to the printer or interpreter.

     -s    Set the default font size (in points) for text objects
          to  fsize. The default is 11*mag, and thus is scaled by
          the -m option.  If there is  no  scaling,  the  default
          font is eleven point Roman."

     -V    Print the program version number only.

     other options
          The other options are specific to the choice of  graph-
          ics language, as described below.


EPIC OPTIONS
     EPIC is an enhancement to LaTeX picture drawing environment.



Sun Microsystems     Last change: 1 Nov 1991                    1






FIG2DEV(1)                User Commands                FIG2DEV(1)



     It  was  developed  by Sunil Podar of Department of Computer
     Science in S.U.N.Y at Stony Brook.

     EEPIC is an extension to  EPIC  and  LaTeX  picture  drawing
     environment  which  uses tpic specials as a graphics mechan-
     ism.  It was written by Conrad Kwok of Division of  Computer
     Science at University of California, Davis.

     EEPIC-EMU is an EEPIC emulation package which does  not  use
     tpic specials.

     -a    Generate alternate font size commands  which  have  an
          initial  capital  letter.  These can be translated into
          latex type size commands by including  the  macro  file
          figfonts.tex.   In  the  resulting  document, type size
          changes apply to text math mode  as  well  as  straight
          text.

     -l    Use "\thicklines" when width of the line is wider than
          lwidth. The default is 2.

     -v    Include comments in the output file.

     -P    Generate a complete LaTeX file. In  other  words,  the
          output  file  can  be  formatted  without requiring any
          changes. The additional text inserted in the  beginning
          and  at the end of the file is controlled by the confi-
          guration parameter "Preamble" and "Postamble".

     -S    Set the scale to which the figure is  rendered.   This
          option automatically sets the magnification and size to
          scale / 12 and scale respectively.

     -W    Enable variable line width

     -w    Disable variable line width. Only "\thicklines" and/or
          "\thinlines"  commands  will be generated in the output
          file.

     When variable line width  option  is  enabled,  "\thinlines"
     command  is  still used when line width is less than LineTh-
     ick. One potential problem is that the width of "\thinlines"
     is  0.4pt  but  the  resolution of Fig is 1/80 inch (approx.
     1pt). If LineThick is set to 2, normal lines will  be  drawn
     in  0.4pt wide lines but the next line width is already 2pt.
     One possible solution is to set LineThick to 1 and  set  the
     width  of  the  those  lines you want to be drawn in "\thin-
     lines"  to 0.

     Due  to  this  problem,  Variable  line  width  VarWidth  is
     defaulted to be false.




Sun Microsystems     Last change: 1 Nov 1991                    2






FIG2DEV(1)                User Commands                FIG2DEV(1)



IBM-GL OPTIONS
     IBM-GL (International Business Machines  Graphics  Language)
     is   compatible   with   HP-GL   (Hewlett-Packard   Graphics
     Language).

     -a    Select ISO A4 (ANSI A) paper size if  the  default  is
          ANSI A (ISO A4) paper size.

     -c    Generate instructions for an IBM  6180  Color  Plotter
          with  (without)  an  IBM Graphics Enhancement Cartridge
          (IBM-GEC).

     -d    Restrict plotting to a rectangular area of the plotter
          paper  which  has a lower left hand corner at (xll,yll)
          and a upper right hand corner at  (xur,yur).  All  four
          numbers are in inches and follow -d in a comma-sparated
          list - xll,yll,xur,yur - with no spaces between them.

     -f    Load text character specifications from the  table  in
          the  fonts  file.  The table must have 36 entries - one
          for each font plus a default.  Each entry consists of 5
          numbers which specify the 1.) standard character set (0
          - 4, 6 - 9, 30 - 39), 2.) alternate character set (0  -
          4,  6  -  9,  30  -  39),  3.)  character  slant  angle
          (degrees), 4.) character width  scale  factor  and  5.)
          character height scale factor.

     -l    Load area fill line patterns from  the  table  in  the
          patterns  file.   The  table must have 21 entries - one
          for each of the area fill patterns.   Each  entry  con-
          sists of 5 numbers which specify the 1.) pattern number
          (-1 - 6), 2.) pattern length (inches), 3.) fill type (1
          -  5),  4.)  fill  spacing  (inches) and 5.) fill angle
          (degrees).

     -m    The magnification may appear as the first element in a
          comma sepatated list - mag,x0,y0 - where the second and
          third parameters specify an offset in inches.

     -p    Load plotter pen specifications from the table in  the
          pens  file.   The  table  must have 9 entries - one for
          each color plus a default.  Each entry  consists  of  2
          numbers  which  specify  the 1.) pen number (1 - 8) and
          2.) pen thickness (millimeters).

     -P    Rotate the figure to portrait  mode.  The  default  is
          landscape mode.

     -S    Set the pen speed to speed (centimeters/second).

     -v    Plot the figure upside-down in portrait mode or  back-
          wards  in  landscape mode.  This allows you to write on



Sun Microsystems     Last change: 1 Nov 1991                    3






FIG2DEV(1)                User Commands                FIG2DEV(1)



          the top surface of overhead transparencies without dis-
          turbing the plotter ink on the bottom surface.

     Fig2dev may be installed  with  either  ANSI  A  or  ISO  A4
     default  paper  size.   The  -a option selects the alternate
     paper size.  Fig2dev does  not  fill  closed  splines.   The
     IBM-GEC  is required to fill other polygons.  Fig2dev may be
     installed for plotters with or without the IBM-GEC.  The  -c
     option selects the alternate instruction set.


LATEX OPTIONS
     -a    Generate alternate  font  size  commands  -  see  epic
          options.

     -l    Sets the threshold between LaTeX thin and thick  lines
          to  lwidth  pixels.   LaTeX supports only two different
          line width: \thinlines and \thicklines.  Lines of width
          greater  than  lwidth  pixels are drawn as \thicklines.
          Also affects the size of dots  in  dotted  line  style.
          The default is 0.

     -d    Set a separate magnification for the  length  of  line
          dashes to dmag.

     -v    Verbose mode.

     LaTeX cannot accurately represent all the  graphics  objects
     which  can  be  described by Fig.  For example, the possible
     slopes which lines may have are limited.  Some objects, such
     as spline curves, cannot be drawn at all.  Fig2latex chooses
     the closest possible line slope, and prints  error  messages
     when objects cannot be drawn accurately


PIC OPTIONS
     -a    Generate alternate  font  size  commands  -  see  epic
          options.

     -p   Enables the use of certain  PIC  extensions  which  are
          known  to  work  with  the groff package; compatibility
          with DWB PIC is unknown.   The  extensions  enabled  by
          each option are:

     arc  Allow ARC_BOX i.e. use rounded corners

     line Use the 'line_thickness' value

     fill Allow ellipses to be filled

     all  Use all of the above




Sun Microsystems     Last change: 1 Nov 1991                    4






FIG2DEV(1)                User Commands                FIG2DEV(1)



PICTEX OUTPUT
     In order to include PiCTeX pictures into a document,  it  is
     necessary to load the PiCTeX macros.

     PiCTeX uses TeX  integer  register  arithmetic  to  generate
     curves,  and  so  it  is  very slow.  PiCTeX draws curves by
     \put-ing the psymbol repeatedly, and  so  requires  a  large
     amount  of  TeX's  internal  memory, and generates large DVI
     files.  The size of TeX's memory limits the number  of  plot
     symbols in a picture.  As a result, it is best to use PiCTeX
     to generate small pictures.


POSTSCRIPT OPTIONS
     With PostScript, Fig can be used to  create  large  posters.
     The  figure will be created by printing multiple pages which
     can be glued together.  Due to memory  limitations  of  most
     laser  printers,  the  figure should not be too complicated.
     Great for text with very big letters.

     Text can now include various ISO-character codes above 0x7f,
     which  is  useful  for  language  specific  characters to be
     printed directly.  Not all ISO-characters are implemented.

     Color support: Colored objects created by Fig can be printed
     on  a  color postscript printer. Currently 8 colors are sup-
     ported: black, blue,  green,  cyan,  red,  magenta,  yellow,
     white.   On  a  monochrome  printer, colored objects will be
     mapped  into  different  grayscales.   Filled  objects   are
     printed  using the given grayscale. If filled with grayscale
     set to 100%, the object will be filled with the  same  color
     as the enclosing line.

     -a    Generate alternate  font  size  commands  -  see  epic
          options.

     -c   option centers the figure on the page.   The  centering
          may  not be accurate if there are texts in the fig_file
          that extends too far to the right of other objects.

     -l dummy_arg
          Rotate figure to landscape mode.  The dummy argument is
          ignored,  but  must appear on the command line for rea-
          sons of compatibility.

     -P   indicates that the figure describes a full  page  which
          will  not  necessarily be inserted into a document, but
          can be sent directly to a  PS  printer.   This  ensures
          that  a  showpage command is inserted at the end of the
          figure, and inhibits translation of the figure  coordi-
          nate system.




Sun Microsystems     Last change: 1 Nov 1991                    5






FIG2DEV(1)                User Commands                FIG2DEV(1)



PSTEX OPTIONS
     The  pstex language is a variant of ps which suppresses for-
          matted  (special)  text.   The pstex_t language has the
          complementary behavior: it generates  only  LaTeX  com-
          mands  necessary to position special text, and to over-
          lay the PostScript file generated  using  pstex.  These
          two drivers can be used to generate a figure which com-
          bines the flexibility of PostScript graphics with LaTeX
          text formatting of special text.

     The  pstex_t option  -p  file  specifies  the  name  of  the
          PostScript  file  to  be  overlaid.   If not set or its
          value is null then no PS file will be inserted.

TEXTYL OPTIONS
     There are no TeXtyl-specific options.


TPIC OPTIONS
     There are no tpic-specific options.


SEE ALSO
     [x]fig(1), pic(1) pic2fig(1), transfig(1)

AUTHORS
     Micah Beck (beck@svax.cs.cornell.edu)
     Cornell University
     Sept 28 1990

     and Frank Schmuck (then of Cornell University)
     and Conrad Kwok (then of U.C. Davis).

     drivers contributed by
     Jose Alberto Fernandez R. (U. of Maryland)
     and Gary Beihl (MCC)

     Color support, ISO-character encoding and poster support by
     Herbert Bauer (heb@regent.e-technik.tu-muenchen.de)

     Modified from f2p (fig to PIC), by the author of Fig
     Supoj Sutanthavibul (supoj@sally.utexas.edu)
     University of Texas at Austin.






Sun Microsystems     Last change: 1 Nov 1991                    6
